OGRE: Ogre::ManualObject Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Ogre::ManualObject Class Reference

`#include <OgreManualObject2.h>`

Inheritance diagram for Ogre::ManualObject:
[legend]

## Classes
class | ManualObjectSection
| Built, renderable section of geometry. More...

## Public Types
typedef FastArray< MovableObject * > | MovableObjectArray
| @See SceneManager::cullFrustum More...
typedef vector< ManualObjectSection * >::type | SectionList

## Public Member Functions
| ManualObject (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager)
virtual | ~ManualObject ()
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object. More...
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only) More...
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state. More...
const Matrix4 & | _getParentNodeFullTransform (void) const
| Returns the full transformation of the parent sceneNode or the attachingPoint node. More...
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node. More...
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only) More...
virtual void | _notifyParentNodeMemoryChanged (void)
| @See Node::_callMemoryChangeListeners More...
virtual void | _notifyStaticDirty (void) const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly. More...
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost. More...
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored. More...
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue. More...
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
virtual_l1 void | begin (const String &datablockName, OperationType opType=OT_TRIANGLE_LIST)
| Start defining a part of the object. More...
virtual_l1 void | beginUpdate (size_t sectionIndex)
| Start the definition of an update to a part of the object. More...
virtual_l1 void | clear (void)
| Completely clear the contents of the object. More...
virtual_l1 void | colour (const ColourValue &col)
| Add a vertex diffuse colour to a vertex. More...
virtual_l1 void | colour (Real r, Real g, Real b, Real a=1.0f)
| Add a vertex diffuse colour to a vertex. More...
virtual_l1 MeshPtr | convertToMesh (const String &meshName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, bool buildShadowMapBuffers=true)
| Convert this object to a Mesh. More...
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value. More...
size_t | currentIndexCount ()
| Get the current count of indices when building a new buffer. More...
size_t | currentVertexCount ()
| Get the current count of vertices when building a new buffer. More...
void | detachFromParent (void)
| Detaches an object from a parent SceneNode if attached. More...
virtual_l1 ManualObjectSection * | end (void)
| Finish defining the object and compile the final renderable version. More...
virtual_l1 void | estimateIndexCount (size_t icount)
| Estimate the number of indices ahead of time. More...
virtual_l1 void | estimateVertexCount (size_t vcount)
| Estimate the number of vertices ahead of time. More...
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object. More...
RealAsUint | getCachedDistanceToCamera (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
Real | getCachedDistanceToCameraAsReal (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object. More...
virtual_l1 size_t | getCurrentIndexCount () const
| Get the number of indices in the section currently being defined (returns 0 if no section is in progress). More...
unsigned char | getCurrentMeshLod (void) const
virtual_l1 size_t | getCurrentVertexCount () const
| Get the number of vertices in the section currently being defined (returns 0 if no section is in progress). More...
IdType | getId () const
| Get the unique id of this object. More...
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object. More...
Listener * | getListener (void) const
| Gets the current listener for this object. More...
Aabb | getLocalAabb (void) const
| Retrieves the local axis-aligned bounding box for this object. More...
float | getLocalRadius (void) const
| See getLocalAabb and getWorldRadius. More...
const String & | getMovableType (void) const
const String & | getName (void) const
| Returns the name of this object. More...
unsigned int | getNumSections (void) const
| Retrieves the number of ManualObjectSection objects making up this ManualObject. More...
Node * | getParentNode (void) const
| Returns the node to which this object is attached. More...
SceneNode * | getParentSceneNode (void) const
uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object. More...
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered. More...
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details. More...
ManualObjectSection * | getSection (const Ogre::String &name) const
| Gets a pointer to a previously named ManualObjectSection (via ManualObjectSection::setName). More...
ManualObjectSection * | getSection (unsigned int index) const
| Gets a pointer to a ManualObjectSection, i.e. More...
Real | getShadowRenderingDistance (void) const
| Gets the distance at which batches are no longer casting shadows. More...
SkeletonInstance * | getSkeletonInstance (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object. More...
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component. More...
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space. More...
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space. More...
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
virtual_l1 void | index (uint32 idx)
| Add a vertex index to construct faces / lines / points. More...
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
| @See InstancingTheadedCullingMethod, More...
bool | isAttached (void) const
| Returns true if this object is attached to a Node. More...
bool | isStatic () const
| Checks whether this MovableObject is static. @See setStatic. More...
bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not. More...
virtual_l1 void | line (uint32 i1, uint32 i2)
| Add a set of 2 vertex indices to construct a line; this is a shortcut to calling index() 2 times. More...
virtual_l1 void | normal (const Vector3 &norm)
| Add a vertex normal to the current vertex. More...
virtual_l1 void | normal (Real x, Real y, Real z)
| Add a vertex normal to the current vertex. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
virtual_l1 void | position (const Vector3 &pos)
| Add a vertex position, starting a new vertex at the same time. More...
virtual_l1 void | position (Real x, Real y, Real z)
| Add a vertex position, starting a new vertex at the same time. More...
virtual_l1 void | quad (uint32 i1, uint32 i2, uint32 i3, uint32 i4)
| Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice. More...
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object. More...
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | removeSection (unsigned int idx)
| Removes the section with given index. More...
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows. More...
void | setDatablock (size_t subIndex, const String &name)
| Alter the material for a subsection of this object after it has been specified. More...
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object. More...
void | setListener (Listener *listener)
| Sets a listener for this object. More...
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object. More...
void | setName (const String &name)
| Sets a custom name for this node. More...
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object. More...
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered. More...
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through. More...
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows. More...
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic. More...
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object. More...
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component. More...
virtual_l1 void | specular (const ColourValue &col)
| Add a vertex specular colour to a vertex. More...
virtual_l1 void | specular (Real r, Real g, Real b, Real a=1.0f)
| Add a vertex specular colour to a vertex. More...
virtual_l1 void | tangent (const Vector3 &tan)
| Add a vertex tangent to the current vertex. More...
virtual_l1 void | tangent (Real x, Real y, Real z)
| Add a vertex tangent to the current vertex. More...
virtual_l1 void | textureCoord (const Vector2 &uv)
| Add a texture coordinate to the current vertex. More...
virtual_l1 void | textureCoord (const Vector3 &uvw)
| Add a texture coordinate to the current vertex. More...
virtual_l1 void | textureCoord (const Vector4 &xyzw)
| Add a texture coordinate to the current vertex. More...
virtual_l1 void | textureCoord (Real u)
| Add a texture coordinate to the current vertex. More...
virtual_l1 void | textureCoord (Real u, Real v)
| Add a texture coordinate to the current vertex. More...
virtual_l1 void | textureCoord (Real u, Real v, Real w)
| Add a texture coordinate to the current vertex. More...
virtual_l1 void | textureCoord (Real x, Real y, Real z, Real w)
| Add a texture coordinate to the current vertex. More...
virtual_l1 void | triangle (uint32 i1, uint32 i2, uint32 i3)
| Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times. More...

## Static Public Member Functions
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
| @See SceneManager::buildLightList More...
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| @See SceneManager::cullLights & More...
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances. More...
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances. More...
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances. More...
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances. More...
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances. More...
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances. More...
static void | updateAllBounds (const size_t numNodes, ObjectData t)
| @See SceneManager::updateAllBounds More...

## Public Attributes
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
RenderableArray | mRenderables

## Static Public Attributes
static const FastArray< Real > | c_DefaultLodMesh

## Member Typedef Documentation

## ◆ MovableObjectArray

typedef FastArray<MovableObject*> Ogre::MovableObject::MovableObjectArray
| inherited

@See SceneManager::cullFrustum

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing) We perform frustum culling AND test visibility mask at the same time

Parameters

  frustum | Frustum to clip against
  sceneVisibilityFlags | Combined scene's visibility flags (i.e. viewport | scene). Set LAYER_SHADOW_CASTER bit if you want to exclude non-shadow casters.
  outCulledObjects | Out. List of objects that are (fully or partially) inside the frustum and should be rendered
  lodCamera | Camera in which lod levels calculations are based (i.e. during shadow pass renders) Note however, we only use this camera to calulate if should be visible according to mUpperDistance

## ◆ SectionList

typedef vector<ManualObjectSection*>::type Ogre::ManualObject::SectionList

## Constructor & Destructor Documentation

## ◆ ManualObject()

Ogre::ManualObject::ManualObject | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager
| ) |  |

## ◆ ~ManualObject()

virtual Ogre::ManualObject::~ManualObject | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _getLightList()

LightList* Ogre::MovableObject::_getLightList | ( |  | ) |
| inlineinherited

Returns a pointer to the current list of lights for this object.

Remarks
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

## ◆ _getManager()

SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const
| inlineinherited

Get the manager of this object, if any (internal use only)

## ◆ _getObjectData()

ObjectData& Ogre::MovableObject::_getObjectData | ( |  | ) |
| inlineinherited

Returns a direct access to the ObjectData state.

## ◆ _getParentNodeFullTransform()

const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const
| inherited

Returns the full transformation of the parent sceneNode or the attachingPoint node.

## ◆ _notifyAttached()

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent | ) |
| virtualinherited

Internal method called to notify the object that it has been attached to a node.

Reimplemented in Ogre::ParticleSystem, and Ogre::v1::Entity.

## ◆ _notifyManager()

void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) |
| inlineinherited

Notify the object of it's manager (internal use only)

## ◆ _notifyParentNodeMemoryChanged()

virtual void Ogre::MovableObject::_notifyParentNodeMemoryChanged | ( | void |  | ) |
| inlinevirtualinherited

@See Node::_callMemoryChangeListeners

Reimplemented in Ogre::Item.

## ◆ _notifyStaticDirty()

virtual void Ogre::MovableObject::_notifyStaticDirty | ( | void |  | ) | const
| inlinevirtualinherited

Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.

See also
  SceneManager::notifyStaticDirty

## ◆ _releaseManualHardwareResources()

virtual void Ogre::MovableObject::_releaseManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources were lost.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented in Ogre::v1::ManualObject, and Ogre::v1::BillboardSet.

## ◆ _restoreManualHardwareResources()

virtual void Ogre::MovableObject::_restoreManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources should be restored.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

## ◆ _updateRenderQueue()

virtual void Ogre::MovableObject::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera
| ) |  |
| inlinevirtualinherited

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

Remarks
  The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Reimplemented in Ogre::v1::StaticGeometry::Region, Ogre::ParticleSystem, Ogre::v1::ManualObject, Ogre::Light, Ogre::v1::Entity, Ogre::v1::BillboardSet, Ogre::MovablePlane, and Ogre::v1::BillboardChain.

## ◆ addQueryFlags()

void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ addVisibilityFlags()

void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ begin()

virtual_l1 void Ogre::ManualObject::begin | ( | const String & | datablockName,
|  | OperationType | opType = `OT_TRIANGLE_LIST`
| ) |  |

Start defining a part of the object.

Remarks
  Each time you call this method, you start a new section of the object with its own material and potentially its own type of rendering operation (triangles, points or lines for example).

Parameters

  datablockName | The name of the datablock to render this part of the object with.
  opType | The type of operation to use to render.

## ◆ beginUpdate()

virtual_l1 void Ogre::ManualObject::beginUpdate | ( | size_t | sectionIndex | ) |

Start the definition of an update to a part of the object.

Remarks
  Using this method, you can update an existing section of the object efficiently. You do not have the option of changing the operation type obviously, since it must match the one that was used before.

Note
  Changing size of the sections is not supported, you are expected to supply the same amount of data with the same layout when updating. If you want to change the data layout, call clear() and create new sections with begin().

Parameters

  sectionIndex | The index of the section you want to update. The first call to begin() would have created section 0, the second section 1, etc.

## ◆ buildLightList()

static void Ogre::MovableObject::buildLightList | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const LightListInfo & | globalLightList
| ) |  |
| staticinherited

@See SceneManager::buildLightList

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

Parameters

  globalLightList | List of lights already culled against all possible frustums and reorganized contiguously for SoA

## ◆ calculateCastersBox()

static void Ogre::MovableObject::calculateCastersBox | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneVisibilityFlags,
|  | AxisAlignedBox * | outBox
| ) |  |
| staticinherited

## ◆ clear()

virtual_l1 void Ogre::ManualObject::clear | ( | void |  | ) |

Completely clear the contents of the object.

Remarks
  Clearing the contents of this object and rebuilding from scratch is not the optimal way to manage dynamic vertex data, since the buffers are recreated. If you want to keep the same structure but update the content within that structure, use beginUpdate() instead of clear() begin(). However if you do want to modify the structure from time to time you can do so by clearing and re-specifying the data.

## ◆ colour() [1/2]

virtual_l1 void Ogre::ManualObject::colour | ( | const ColourValue & | col | ) |

Add a vertex diffuse colour to a vertex.

## ◆ colour() [2/2]

virtual_l1 void Ogre::ManualObject::colour | ( | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a = `1.0f`
| ) |  |

Add a vertex diffuse colour to a vertex.

Parameters

  r,g,b,a | Colour components expressed as floating point numbers from 0-1

## ◆ convertToMesh()

virtual_l1 MeshPtr Ogre::ManualObject::convertToMesh | ( | const String & | meshName,
|  | const String & | groupName = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`,
|  | bool | buildShadowMapBuffers = `true`
| ) |  |

Convert this object to a Mesh.

Remarks
  After you've finished building this object, you may convert it to a Mesh if you want in order to be able to create many instances of it in the world (via Item). This is optional, since this instance can be directly attached to a SceneNode itself, but of course only one instance of it can exist that way.

Note
  Only objects which use indexed geometry may be converted to a mesh.

Parameters

  meshName | The name to give the mesh
  groupName | The resource group to create the mesh in
  buildShadowMapBuffers | True to create an optimized copy of the vertex buffers for efficient shadow mapping.

## ◆ createAnimableValue()

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) |
| inlinevirtualinherited

Create a reference-counted AnimableValuePtr for the named value.

Remarks
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ cullFrustum()

static void Ogre::MovableObject::cullFrustum | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const Camera * | frustum,
|  | uint32 | sceneVisibilityFlags,
|  | MovableObjectArray & | outCulledObjects,
|  | const Camera * | lodCamera
| ) |  |
| staticinherited

## ◆ cullLights()

static void Ogre::MovableObject::cullLights | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneLightMask,
|  | LightListInfo & | outGlobalLightList,
|  | const FrustumVec & | frustums,
|  | const FrustumVec & | cubemapFrustums
| ) |  |
| staticinherited

@See SceneManager::cullLights &

See also
  MovableObject::cullFrustum Produces the global list of visible lights that is needed in buildLightList

Remarks
  We don't pass ObjectData by reference on purpose (avoid implicit aliasing) It's declared here because all affected elements are from MovableObject IMPORTANT: It is assumed that all objects in ObjectData are Lights.

Parameters

  outGlobalLightList | Output, a list of lights, contiguously placed
  frustums | An array of all frustums we need to check against
  cubemapFrustums | An array of all frustums that are used at least once as cubemaps (@See SceneManager::createCamera)

## ◆ currentIndexCount()

size_t Ogre::ManualObject::currentIndexCount | ( |  | ) |

Get the current count of indices when building a new buffer.

Returns
  Index count

## ◆ currentVertexCount()

size_t Ogre::ManualObject::currentVertexCount | ( |  | ) |

Get the current count of vertices when building a new buffer.

Returns
  Vertex count

## ◆ detachFromParent()

void Ogre::MovableObject::detachFromParent | ( | void |  | ) |
| inherited

Detaches an object from a parent SceneNode if attached.

## ◆ end()

virtual_l1 ManualObjectSection* Ogre::ManualObject::end | ( | void |  | ) |

Finish defining the object and compile the final renderable version.

Note
  Will return a pointer to the finished section or NULL if the section was discarded (i.e. has zero vertices/indices).

## ◆ estimateIndexCount()

virtual_l1 void Ogre::ManualObject::estimateIndexCount | ( | size_t | icount | ) |

Estimate the number of indices ahead of time.

Remarks
  Calling this helps to avoid memory reallocation when you first define indices with begin() -> end() sequence.

## ◆ estimateVertexCount()

virtual_l1 void Ogre::ManualObject::estimateVertexCount | ( | size_t | vcount | ) |

Estimate the number of vertices ahead of time.

Remarks
  Calling this helps to avoid memory reallocation when you first define indices with begin() -> end() sequence.

## ◆ getAnimableValueNames()

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const
| inlineinherited

Gets a list of animable value names for this object.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getCachedDistanceToCamera()

RealAsUint Ogre::MovableObject::getCachedDistanceToCamera | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCachedDistanceToCameraAsReal()

Real Ogre::MovableObject::getCachedDistanceToCameraAsReal | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCastShadows()

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const
| inlineinherited

Returns whether shadow casting is enabled for this object.

## ◆ getCurrentIndexCount()

virtual_l1 size_t Ogre::ManualObject::getCurrentIndexCount | ( |  | ) | const

Get the number of indices in the section currently being defined (returns 0 if no section is in progress).

## ◆ getCurrentMeshLod()

unsigned char Ogre::MovableObject::getCurrentMeshLod | ( | void |  | ) | const
| inlineinherited

## ◆ getCurrentVertexCount()

virtual_l1 size_t Ogre::ManualObject::getCurrentVertexCount | ( |  | ) | const

Get the number of vertices in the section currently being defined (returns 0 if no section is in progress).

## ◆ getDefaultLightMask()

static uint32 Ogre::MovableObject::getDefaultLightMask | ( |  | ) |
| inlinestaticinherited

Get the default light mask for all future MovableObject instances.

## ◆ getDefaultQueryFlags()

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) |
| inlinestaticinherited

Get the default query flags for all future MovableObject instances.

## ◆ getDefaultVisibilityFlags()

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) |
| inlinestaticinherited

Get the default visibility flags for all future MovableObject instances.

## ◆ getId()

IdType Ogre::IdObject::getId | ( |  | ) | const
| inlineinherited

Get the unique id of this object.

## ◆ getLightMask()

uint32 Ogre::MovableObject::getLightMask | ( |  | ) | const
| inlineinherited

Get a bitwise mask which will filter the lights affecting this object.

Remarks
  By default, this mask is fully set meaning all lights will affect this object

## ◆ getListener()

Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const
| inlineinherited

Gets the current listener for this object.

## ◆ getLocalAabb()

Aabb Ogre::MovableObject::getLocalAabb | ( | void |  | ) | const
| inherited

Retrieves the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ getLocalRadius()

float Ogre::MovableObject::getLocalRadius | ( | void |  | ) | const
| inherited

See getLocalAabb and getWorldRadius.

## ◆ getMovableType()

const String& Ogre::ManualObject::getMovableType | ( | void |  | ) | const
| virtual

Implements Ogre::MovableObject.

## ◆ getName()

const String& Ogre::MovableObject::getName | ( | void |  | ) | const
| inlineinherited

Returns the name of this object.

## ◆ getNumSections()

unsigned int Ogre::ManualObject::getNumSections | ( | void |  | ) | const

Retrieves the number of ManualObjectSection objects making up this ManualObject.

## ◆ getParentNode()

Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const
| inlineinherited

Returns the node to which this object is attached.

## ◆ getParentSceneNode()

SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const
| inlineinherited

## ◆ getQueryFlags()

uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const
| inlineinherited

Returns the query flags relevant for this object.

## ◆ getRenderingDistance()

Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer rendered.

## ◆ getRenderingMinPixelSize()

Real Ogre::MovableObject::getRenderingMinPixelSize | ( |  | ) | const
| inlineinherited

Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.

## ◆ getRenderQueueGroup()

uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const
| inlineinherited

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## ◆ getSection() [1/2]

ManualObjectSection* Ogre::ManualObject::getSection | ( | const Ogre::String & | name | ) | const

Gets a pointer to a previously named ManualObjectSection (via ManualObjectSection::setName).

## ◆ getSection() [2/2]

ManualObjectSection* Ogre::ManualObject::getSection | ( | unsigned int | index | ) | const

Gets a pointer to a ManualObjectSection, i.e.

a part of a ManualObject.

## ◆ getShadowRenderingDistance()

Real Ogre::MovableObject::getShadowRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer casting shadows.

## ◆ getSkeletonInstance()

SkeletonInstance* Ogre::MovableObject::getSkeletonInstance | ( | void |  | ) | const
| inlineinherited

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getVisibilityFlags()

uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const
| inlineinherited

Returns the visibility flags relevant for this object.

Reserved visibility flags are not returned.

## ◆ getVisible()

bool Ogre::MovableObject::getVisible | ( | void |  | ) | const
| inlineinherited

Gets this object whether to be visible or not, if it has a renderable component.

Remarks
  Returns the value set by MovableObject::setVisible only.

## ◆ getWorldAabb()

Aabb Ogre::MovableObject::getWorldAabb | ( |  | ) | const
| inherited

Gets the axis aligned box in world space.

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldAabbUpdated if you need the update process to be guaranteed

## ◆ getWorldAabbUpdated()

Aabb Ogre::MovableObject::getWorldAabbUpdated | ( |  | ) |
| inherited

Gets the axis aligned box in world space.

Remarks
  Unlike getWorldAabb, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ getWorldRadius()

float Ogre::MovableObject::getWorldRadius | ( |  | ) | const
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldRadiusUpdated if you need the update process to be guaranteed

## ◆ getWorldRadiusUpdated()

float Ogre::MovableObject::getWorldRadiusUpdated | ( |  | ) |
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Unlike getWorldRadius, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ index()

virtual_l1 void Ogre::ManualObject::index | ( | uint32 | idx | ) |

Add a vertex index to construct faces / lines / points.

Remarks
  You will have to call this 3 times for each face for a triangle list, or use the alternative 3-parameter version. Other operation types require different numbers of indexes,

See also
  OperationType.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  idx | A vertex index from 0 to 4294967295.

Referenced by Ogre::Volume::MeshBuilder::addCubeToManualObject().

## ◆ instanceBatchCullFrustumThreaded()

virtual void Ogre::MovableObject::instanceBatchCullFrustumThreaded | ( | const Frustum * | frustum,
|  | const Camera * | lodCamera,
|  | uint32 | combinedVisibilityFlags
| ) |  |
| inlinevirtualinherited

@See InstancingTheadedCullingMethod,

See also
  InstanceBatch::instanceBatchCullFrustumThreaded

## ◆ isAttached()

bool Ogre::MovableObject::isAttached | ( | void |  | ) | const
| inlineinherited

Returns true if this object is attached to a Node.

## ◆ isStatic()

bool Ogre::MovableObject::isStatic | ( |  | ) | const
| inherited

Checks whether this MovableObject is static. @See setStatic.

## ◆ isVisible()

bool Ogre::MovableObject::isVisible | ( | void |  | ) | const
| inherited

Returns whether or not this object is supposed to be visible or not.

Remarks
  Takes into account visibility flags and the setVisible, but not rendering distance.

## ◆ line()

virtual_l1 void Ogre::ManualObject::line | ( | uint32 | i1,
|  | uint32 | i2
| ) |  |

Add a set of 2 vertex indices to construct a line; this is a shortcut to calling index() 2 times.

It is only valid for line lists.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2 | 2 vertex indices from 0 to 4294967295 defining a face.

## ◆ normal() [1/2]

virtual_l1 void Ogre::ManualObject::normal | ( | const Vector3 & | norm | ) |

Add a vertex normal to the current vertex.

Remarks
  Vertex normals are most often used for dynamic lighting, and their components should be normalised.

## ◆ normal() [2/2]

virtual_l1 void Ogre::ManualObject::normal | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |

Add a vertex normal to the current vertex.

Remarks
  Vertex normals are most often used for dynamic lighting, and their components should be normalised.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ operator()() [1/2]

bool Ogre::IdObject::operator() | ( | const IdObject & | left,
|  | const IdObject & | right
| ) |  |
| inlineinherited

## ◆ operator()() [2/2]

bool Ogre::IdObject::operator() | ( | const IdObject * | left,
|  | const IdObject * | right
| ) |  |
| inlineinherited

## ◆ position() [1/2]

virtual_l1 void Ogre::ManualObject::position | ( | const Vector3 & | pos | ) |

Add a vertex position, starting a new vertex at the same time.

Remarks
  A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().

Referenced by Ogre::Volume::MeshBuilder::addCubeToManualObject().

## ◆ position() [2/2]

virtual_l1 void Ogre::ManualObject::position | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |

Add a vertex position, starting a new vertex at the same time.

Remarks
  A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().

## ◆ quad()

virtual_l1 void Ogre::ManualObject::quad | ( | uint32 | i1,
|  | uint32 | i2,
|  | uint32 | i3,
|  | uint32 | i4
| ) |  |

Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice.

It's only valid for triangle list operations.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2,i3,i4 | 4 vertex indices from 0 to 4294967295 defining a quad.

## ◆ queryLights()

const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const
| inlineinherited

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks
  The lights are filled in

See also
  buildLightList

Returns
  The list of lights use to lighting this object.

## ◆ removeQueryFlags()

void Ogre::MovableObject::removeQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ removeSection()

void Ogre::ManualObject::removeSection | ( | unsigned int | idx | ) |

Removes the section with given index.

Parameters

  idx | Index of section to remove.

## ◆ removeVisibilityFlags()

void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ setCastShadows()

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) |
| inlineinherited

Sets whether or not this object will cast shadows.

Remarks
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

## ◆ setDatablock()

void Ogre::ManualObject::setDatablock | ( | size_t | subIndex,
|  | const String & | name
| ) |  |

Alter the material for a subsection of this object after it has been specified.

Remarks
  You specify the datablock to use on a section of this object during the call to begin(), however if you want to change the datablock afterwards you can do so by calling this method.

Note
  This function is a shortcut of calling Renderable::setDatablock() on all sections in this manual object. If you want to set a datablock with pointer instead of ID string, you need to get the section and call the appropriate function.

Parameters

  subIndex | The index of the subsection to alter
  name | The name of the new datablock to use

## ◆ setDefaultLightMask()

static void Ogre::MovableObject::setDefaultLightMask | ( | uint32 | mask | ) |
| inlinestaticinherited

Set the default light mask for all future MovableObject instances.

## ◆ setDefaultQueryFlags()

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default query flags for all future MovableObject instances.

## ◆ setDefaultVisibilityFlags()

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default visibility flags for all future MovableObject instances.

## ◆ setLightMask()

void Ogre::MovableObject::setLightMask | ( | uint32 | lightMask | ) |
| inlineinherited

Set a bitwise mask which will filter the lights affecting this object.

Remarks
  This mask will be compared against the mask held against Light to determine if a light should affect a given object. By default, this mask is fully set meaning all lights will affect this object

## ◆ setListener()

void Ogre::MovableObject::setListener | ( | Listener * | listener | ) |
| inlineinherited

Sets a listener for this object.

Remarks
  Note for size and performance reasons only one listener per object is allowed.

## ◆ setLocalAabb()

void Ogre::MovableObject::setLocalAabb | ( | const Aabb | box | ) |
| inherited

Sets the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ setName()

void Ogre::MovableObject::setName | ( | const String & | name | ) |
| inlineinherited

Sets a custom name for this node.

Doesn't have to be unique

## ◆ setQueryFlags()

void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the query flags for this object.

Remarks
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

## ◆ setRenderingDistance()

void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer rendered.

Parameters

  dist | Distance beyond which the object will not be rendered (the default is FLT_MAX, which means objects are always rendered). Values equal or below zero will be ignored, and cause an assertion in debug mode.

## ◆ setRenderingMinPixelSize()

void Ogre::MovableObject::setRenderingMinPixelSize | ( | Real | pixelSize | ) |
| inlineinherited

Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.

Note
  Camera::setUseMinPixelSize() needs to be called for this parameter to be used.

Parameters

  pixelSize | Number of minimum pixels (the default is 0, which means objects are always rendered).

## ◆ setRenderQueueGroup()

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) |
| virtualinherited

Sets the render queue group this entity will be rendered through.

Remarks
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

  Valid render queue ids are between 0 & 254 inclusive

Reimplemented in Ogre::ParticleSystem, Ogre::Light, Ogre::InternalCubemapProbe, Ogre::v1::Entity, and Ogre::Decal.

## ◆ setShadowRenderingDistance()

void Ogre::MovableObject::setShadowRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer casting shadows.

Parameters

  dist | Distance beyond which the object will not cast shadows (the default is FLT_MAX, which means objects are always casting shadows). Values equal or below zero will be ignored, and cause an assertion in debug mode.

Note
  ShadowRenderingDistance will be clamped to RenderingDistance value

See also
  setRenderingDistance

## ◆ setStatic()

bool Ogre::MovableObject::setStatic | ( | bool | bStatic | ) |
| inherited

Turns this Node into static or dynamic.

Remarks
  Switching between dynamic and static has some overhead and forces to update all static scene when converted to static. So don't do it frequently. Static objects are not updated every frame, only when requested explicitly. Use this feature if you plan to have this object unaltered for a very long times

  Note all MovableObjects support switching between static & dynamic after they have been created (eg. InstancedEntity)

  Changing this attribute will cause to switch the attribute to our parent node, and as a result, all of its other attached entities. @See Node::setStatic

Returns
  True if setStatic made an actual change. False otherwise. Can fail because the object was already static/dynamic, or because switching is not supported

## ◆ setVisibilityFlags()

void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the visibility flags for this object.

Remarks
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visibility flags that is applied a binary 'and' with the SceneManager's mask and a compositor node pass. To exclude particular objects from rendering. Changes to reserved visibility flags are ignored (won't take effect).

## ◆ setVisible()

void Ogre::MovableObject::setVisible | ( | bool | visible | ) |
| inlineinherited

Tells this object whether to be visible or not, if it has a renderable component.

Note
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

## ◆ specular() [1/2]

virtual_l1 void Ogre::ManualObject::specular | ( | const ColourValue & | col | ) |

Add a vertex specular colour to a vertex.

## ◆ specular() [2/2]

virtual_l1 void Ogre::ManualObject::specular | ( | Real | r,
|  | Real | g,
|  | Real | b,
|  | Real | a = `1.0f`
| ) |  |

Add a vertex specular colour to a vertex.

Parameters

  r,g,b,a | Colour components expressed as floating point numbers from 0-1

## ◆ tangent() [1/2]

virtual_l1 void Ogre::ManualObject::tangent | ( | const Vector3 & | tan | ) |

Add a vertex tangent to the current vertex.

Remarks
  Vertex tangents are most often used for dynamic lighting, and their components should be normalised. Also, using tangent() you enable VES_TANGENT vertex semantic, which is not supported on old non-SM2 cards.

## ◆ tangent() [2/2]

virtual_l1 void Ogre::ManualObject::tangent | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |

Add a vertex tangent to the current vertex.

Remarks
  Vertex tangents are most often used for dynamic lighting, and their components should be normalised. Also, using tangent() you enable VES_TANGENT vertex semantic, which is not supported on old non-SM2 cards.

## ◆ textureCoord() [1/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | const Vector2 & | uv | ) |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [2/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | const Vector3 & | uvw | ) |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [3/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | const Vector4 & | xyzw | ) |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [4/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | Real | u | ) |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [5/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | Real | u,
|  | Real | v
| ) |  |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [6/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | Real | u,
|  | Real | v,
|  | Real | w
| ) |  |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ textureCoord() [7/7]

virtual_l1 void Ogre::ManualObject::textureCoord | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | Real | w
| ) |  |

Add a texture coordinate to the current vertex.

Remarks
  You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

## ◆ triangle()

virtual_l1 void Ogre::ManualObject::triangle | ( | uint32 | i1,
|  | uint32 | i2,
|  | uint32 | i3
| ) |  |

Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times.

It is only valid for triangle lists.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2,i3 | 3 vertex indices from 0 to 4294967295 defining a face.

## ◆ updateAllBounds()

static void Ogre::MovableObject::updateAllBounds | ( | const size_t | numNodes,
|  | ObjectData | t
| ) |  |
| staticinherited

@See SceneManager::updateAllBounds

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

## Member Data Documentation

## ◆ c_DefaultLodMesh

const FastArray<Real> Ogre::MovableObject::c_DefaultLodMesh
| staticinherited

## ◆ mGlobalIndex

size_t Ogre::MovableObject::mGlobalIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mParentIndex

size_t Ogre::MovableObject::mParentIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mRenderables

RenderableArray Ogre::MovableObject::mRenderables
| inherited

The documentation for this class was generated from the following file:

- OgreManualObject2.h